Hex Artifact Content

Artifact beb5ae7496115039d96a1a35ebb71f3cb005b6f1:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 4c 53 56 45 52 53 3d 22 31 2e 36 2e 37 22 0a 53  LSVERS="1.6.7".S
0100: 52 43 3d 22 73 72 63 2f 74 6c 73 2d 24 7b 54 4c  RC="src/tls-${TL
0110: 53 56 45 52 53 7d 2e 74 61 72 2e 67 7a 22 0a 53  SVERS}.tar.gz".S
0120: 52 43 55 52 4c 3d 22 68 74 74 70 3a 2f 2f 73 6f  RCURL="http://so
0130: 75 72 63 65 66 6f 72 67 65 2e 6e 65 74 2f 70 72  urceforge.net/pr
0140: 6f 6a 65 63 74 73 2f 74 6c 73 2f 66 69 6c 65 73  ojects/tls/files
0150: 2f 74 6c 73 2f 24 7b 54 4c 53 56 45 52 53 7d 2f  /tls/${TLSVERS}/
0160: 74 6c 73 24 7b 54 4c 53 56 45 52 53 7d 2d 73 72  tls${TLSVERS}-sr
0170: 63 2e 74 61 72 2e 67 7a 22 0a 53 52 43 48 41 53  c.tar.gz".SRCHAS
0180: 48 3d 27 2d 27 0a 42 55 49 4c 44 44 49 52 3d 22  H='-'.BUILDDIR="
0190: 24 28 70 77 64 29 2f 62 75 69 6c 64 2f 74 6c 73  $(pwd)/build/tls
01a0: 24 7b 54 4c 53 56 45 52 53 7d 22 0a 4f 55 54 44  ${TLSVERS}".OUTD
01b0: 49 52 3d 22 24 28 70 77 64 29 2f 6f 75 74 22 0a  IR="$(pwd)/out".
01c0: 49 4e 53 54 44 49 52 3d 22 24 28 70 77 64 29 2f  INSTDIR="$(pwd)/
01d0: 69 6e 73 74 22 0a 50 41 54 43 48 44 49 52 3d 22  inst".PATCHDIR="
01e0: 24 28 70 77 64 29 2f 70 61 74 63 68 65 73 22 0a  $(pwd)/patches".
01f0: 65 78 70 6f 72 74 20 54 4c 53 56 45 52 53 20 53  export TLSVERS S
0200: 52 43 20 53 52 43 55 52 4c 20 42 55 49 4c 44 44  RC SRCURL BUILDD
0210: 49 52 20 4f 55 54 44 49 52 20 49 4e 53 54 44 49  IR OUTDIR INSTDI
0220: 52 20 50 41 54 43 48 44 49 52 0a 0a 23 20 53 65  R PATCHDIR..# Se
0230: 74 20 63 6f 6e 66 69 67 75 72 65 20 6f 70 74 69  t configure opti
0240: 6f 6e 73 20 66 6f 72 20 74 68 69 73 20 73 75 62  ons for this sub
0250: 2d 70 72 6f 6a 65 63 74 0a 4c 44 46 4c 41 47 53  -project.LDFLAGS
0260: 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 24 7b 4b  ="${LDFLAGS} ${K
0270: 43 5f 54 4c 53 5f 4c 44 46 4c 41 47 53 7d 22 0a  C_TLS_LDFLAGS}".
0280: 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47 53  CFLAGS="${CFLAGS
0290: 7d 20 24 7b 4b 43 5f 54 4c 53 5f 43 46 4c 41 47  } ${KC_TLS_CFLAG
02a0: 53 7d 22 0a 43 50 50 46 4c 41 47 53 3d 22 24 7b  S}".CPPFLAGS="${
02b0: 43 50 50 46 4c 41 47 53 7d 20 24 7b 4b 43 5f 54  CPPFLAGS} ${KC_T
02c0: 4c 53 5f 43 50 50 46 4c 41 47 53 7d 22 0a 4c 49  LS_CPPFLAGS}".LI
02d0: 42 53 3d 22 24 7b 4c 49 42 53 7d 20 24 7b 4b 43  BS="${LIBS} ${KC
02e0: 5f 54 4c 53 5f 4c 49 42 53 7d 22 0a 65 78 70 6f  _TLS_LIBS}".expo
02f0: 72 74 20 4c 44 46 4c 41 47 53 20 43 46 4c 41 47  rt LDFLAGS CFLAG
0300: 53 20 43 50 50 46 4c 41 47 53 20 4c 49 42 53 0a  S CPPFLAGS LIBS.
0310: 0a 72 6d 20 2d 72 66 20 27 62 75 69 6c 64 27 20  .rm -rf 'build' 
0320: 27 6f 75 74 27 20 27 69 6e 73 74 27 0a 6d 6b 64  'out' 'inst'.mkd
0330: 69 72 20 27 62 75 69 6c 64 27 20 27 6f 75 74 27  ir 'build' 'out'
0340: 20 27 69 6e 73 74 27 20 7c 7c 20 65 78 69 74 20   'inst' || exit 
0350: 31 0a 0a 54 43 4c 5f 56 45 52 53 49 4f 4e 3d 22  1..TCL_VERSION="
0360: 75 6e 6b 6e 6f 77 6e 22 0a 69 66 20 5b 20 2d 66  unknown".if [ -f
0370: 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52   "${TCLCONFIGDIR
0380: 7d 2f 74 63 6c 43 6f 6e 66 69 67 2e 73 68 22 20  }/tclConfig.sh" 
0390: 5d 3b 20 74 68 65 6e 0a 20 20 20 20 20 20 20 20  ]; then.        
03a0: 73 6f 75 72 63 65 20 22 24 7b 54 43 4c 43 4f 4e  source "${TCLCON
03b0: 46 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e 66 69  FIGDIR}/tclConfi
03c0: 67 2e 73 68 22 0a 66 69 0a 65 78 70 6f 72 74 20  g.sh".fi.export 
03d0: 54 43 4c 5f 56 45 52 53 49 4f 4e 0a 0a 69 66 20  TCL_VERSION..if 
03e0: 5b 20 21 20 2d 66 20 22 24 7b 53 52 43 7d 22 20  [ ! -f "${SRC}" 
03f0: 5d 3b 20 74 68 65 6e 0a 09 6d 6b 64 69 72 20 27  ]; then..mkdir '
0400: 73 72 63 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  src' >/dev/null 
0410: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 0a 09 69 66  2>/dev/null...if
0420: 20 5b 20 21 20 2d 64 20 27 62 75 69 6c 64 73 72   [ ! -d 'buildsr
0430: 63 27 20 5d 3b 20 74 68 65 6e 0a 09 09 64 6f 77  c' ]; then...dow
0440: 6e 6c 6f 61 64 20 22 24 7b 53 52 43 55 52 4c 7d  nload "${SRCURL}
0450: 22 20 22 24 7b 53 52 43 7d 22 20 22 24 7b 53 52  " "${SRC}" "${SR
0460: 43 48 41 53 48 7d 22 20 7c 7c 20 65 78 69 74 20  CHASH}" || exit 
0470: 31 0a 09 66 69 0a 66 69 0a 0a 28 0a 09 63 64 20  1..fi.fi..(..cd 
0480: 27 62 75 69 6c 64 27 20 7c 7c 20 65 78 69 74 20  'build' || exit 
0490: 31 0a 0a 09 69 66 20 5b 20 21 20 2d 64 20 27 2e  1...if [ ! -d '.
04a0: 2e 2f 62 75 69 6c 64 73 72 63 27 20 5d 3b 20 74  ./buildsrc' ]; t
04b0: 68 65 6e 0a 09 09 67 7a 69 70 20 2d 64 63 20 22  hen...gzip -dc "
04c0: 2e 2e 2f 24 7b 53 52 43 7d 22 20 7c 20 74 61 72  ../${SRC}" | tar
04d0: 20 2d 78 66 20 2d 0a 09 65 6c 73 65 20 20 20 20   -xf -..else    
04e0: 0a 09 09 63 70 20 2d 72 70 20 2e 2e 2f 62 75 69  ...cp -rp ../bui
04f0: 6c 64 73 72 63 2f 2a 20 27 2e 2f 27 0a 09 66 69  ldsrc/* './'..fi
0500: 0a 0a 09 23 20 44 65 74 65 72 6d 69 6e 65 20 53  ...# Determine S
0510: 53 4c 20 64 69 72 65 63 74 6f 72 79 0a 09 69 66  SL directory..if
0520: 20 5b 20 2d 7a 20 22 24 7b 43 50 50 7d 22 20 5d   [ -z "${CPP}" ]
0530: 3b 20 74 68 65 6e 0a 09 09 43 50 50 3d 22 24 7b  ; then...CPP="${
0540: 43 43 7d 20 2d 45 22 0a 09 66 69 0a 0a 09 69 66  CC} -E"..fi...if
0550: 20 5b 20 2d 6e 20 22 24 7b 4b 43 5f 54 4c 53 5f   [ -n "${KC_TLS_
0560: 53 53 4c 44 49 52 7d 22 20 5d 3b 20 74 68 65 6e  SSLDIR}" ]; then
0570: 0a 09 09 53 53 4c 44 49 52 3d 22 24 7b 4b 43 5f  ...SSLDIR="${KC_
0580: 54 4c 53 5f 53 53 4c 44 49 52 7d 22 0a 09 65 6c  TLS_SSLDIR}"..el
0590: 73 65 0a 09 09 53 53 4c 44 49 52 3d 22 24 28 65  se...SSLDIR="$(e
05a0: 63 68 6f 20 27 23 69 6e 63 6c 75 64 65 20 3c 6f  cho '#include <o
05b0: 70 65 6e 73 73 6c 2f 73 73 6c 2e 68 3e 27 20 32  penssl/ssl.h>' 2
05c0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 24 7b 43  >/dev/null | ${C
05d0: 50 50 7d 20 2d 20 7c 20 61 77 6b 20 27 2f 23 20  PP} - | awk '/# 
05e0: 31 20 22 5c 2f 2e 2a 5c 2f 73 73 6c 5c 2e 68 2f  1 "\/.*\/ssl\.h/
05f0: 7b 20 70 72 69 6e 74 20 24 33 3b 20 65 78 69 74  { print $3; exit
0600: 20 7d 27 20 7c 20 73 65 64 20 27 73 40 5e 22 40   }' | sed 's@^"@
0610: 40 3b 73 40 22 24 40 40 3b 73 40 2f 69 6e 63 6c  @;s@"$@@;s@/incl
0620: 75 64 65 2f 6f 70 65 6e 73 73 6c 2f 73 73 6c 5c  ude/openssl/ssl\
0630: 2e 68 24 40 40 27 29 22 0a 09 09 69 66 20 5b 20  .h$@@')"...if [ 
0640: 2d 7a 20 22 24 7b 53 53 4c 44 49 52 7d 22 20 5d  -z "${SSLDIR}" ]
0650: 3b 20 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 22  ; then....echo "
0660: 55 6e 61 62 6c 65 20 74 6f 20 66 69 6e 64 20 4f  Unable to find O
0670: 70 65 6e 53 53 4c 2c 20 61 62 6f 72 74 69 6e 67  penSSL, aborting
0680: 2e 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  ." >&2.....exit 
0690: 31 0a 09 09 66 69 0a 09 66 69 0a 0a 09 23 20 41  1...fi..fi...# A
06a0: 70 70 6c 79 20 72 65 71 75 69 72 65 64 20 70 61  pply required pa
06b0: 74 63 68 65 73 0a 09 63 64 20 22 24 7b 42 55 49  tches..cd "${BUI
06c0: 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74 20  LDDIR}" || exit 
06d0: 31 0a 09 66 6f 72 20 70 61 74 63 68 20 69 6e 20  1..for patch in 
06e0: 22 24 7b 50 41 54 43 48 44 49 52 7d 2f 61 6c 6c  "${PATCHDIR}/all
06f0: 22 2f 74 6c 73 2d 24 7b 54 4c 53 56 45 52 53 7d  "/tls-${TLSVERS}
0700: 2d 2a 2e 64 69 66 66 20 22 24 7b 50 41 54 43 48  -*.diff "${PATCH
0710: 44 49 52 7d 2f 24 7b 54 43 4c 5f 56 45 52 53 49  DIR}/${TCL_VERSI
0720: 4f 4e 7d 22 2f 74 6c 73 2d 24 7b 54 4c 53 56 45  ON}"/tls-${TLSVE
0730: 52 53 7d 2d 2a 2e 64 69 66 66 3b 20 64 6f 0a 09  RS}-*.diff; do..
0740: 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 70 61  .if [ ! -f "${pa
0750: 74 63 68 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  tch}" ]; then...
0760: 09 63 6f 6e 74 69 6e 75 65 0a 09 09 66 69 0a 0a  .continue...fi..
0770: 09 09 65 63 68 6f 20 22 41 70 70 6c 79 69 6e 67  ..echo "Applying
0780: 3a 20 24 7b 70 61 74 63 68 7d 22 0a 09 09 24 7b  : ${patch}"...${
0790: 50 41 54 43 48 3a 2d 70 61 74 63 68 7d 20 2d 70  PATCH:-patch} -p
07a0: 31 20 3c 20 22 24 7b 70 61 74 63 68 7d 22 0a 09  1 < "${patch}"..
07b0: 64 6f 6e 65 0a 0a 09 63 64 20 22 24 7b 42 55 49  done...cd "${BUI
07c0: 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69 74 20  LDDIR}" || exit 
07d0: 31 0a 0a 09 23 20 54 72 79 20 74 6f 20 62 75 69  1...# Try to bui
07e0: 6c 64 20 61 73 20 61 20 73 68 61 72 65 64 20 6f  ld as a shared o
07f0: 62 6a 65 63 74 20 69 66 20 72 65 71 75 65 73 74  bject if request
0800: 65 64 0a 09 69 66 20 5b 20 22 24 7b 53 54 41 54  ed..if [ "${STAT
0810: 49 43 54 4c 53 7d 22 20 3d 20 22 30 22 20 5d 3b  ICTLS}" = "0" ];
0820: 20 74 68 65 6e 0a 09 09 74 72 79 6f 70 74 73 3d   then...tryopts=
0830: 22 2d 2d 65 6e 61 62 6c 65 2d 73 68 61 72 65 64  "--enable-shared
0840: 20 2d 2d 64 69 73 61 62 6c 65 2d 73 68 61 72 65   --disable-share
0850: 64 22 0a 09 65 6c 69 66 20 5b 20 22 24 7b 53 54  d"..elif [ "${ST
0860: 41 54 49 43 54 4c 53 7d 22 20 3d 20 22 2d 31 22  ATICTLS}" = "-1"
0870: 20 5d 3b 20 74 68 65 6e 0a 09 09 74 72 79 6f 70   ]; then...tryop
0880: 74 73 3d 22 2d 2d 65 6e 61 62 6c 65 2d 73 68 61  ts="--enable-sha
0890: 72 65 64 22 0a 09 65 6c 73 65 0a 09 09 74 72 79  red"..else...try
08a0: 6f 70 74 73 3d 22 2d 2d 64 69 73 61 62 6c 65 2d  opts="--disable-
08b0: 73 68 61 72 65 64 22 0a 09 66 69 0a 0a 09 23 20  shared"..fi...# 
08c0: 44 69 73 61 62 6c 65 20 53 53 4c 76 32 2c 20 6e  Disable SSLv2, n
08d0: 65 77 65 72 20 53 53 4c 20 6c 69 62 72 61 72 69  ewer SSL librari
08e0: 65 73 20 64 72 6f 70 20 73 75 70 70 6f 72 74 20  es drop support 
08f0: 66 6f 72 20 69 74 20 65 6e 74 69 72 65 6c 79 0a  for it entirely.
0900: 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c 41 47  .CFLAGS="${CFLAG
0910: 53 7d 20 2d 44 4e 4f 5f 53 53 4c 32 3d 31 22 0a  S} -DNO_SSL2=1".
0920: 0a 09 53 41 56 45 5f 43 46 4c 41 47 53 3d 22 24  ..SAVE_CFLAGS="$
0930: 7b 43 46 4c 41 47 53 7d 22 0a 09 53 41 56 45 5f  {CFLAGS}"..SAVE_
0940: 4c 49 42 53 3d 22 24 7b 4c 49 42 53 7d 22 0a 09  LIBS="${LIBS}"..
0950: 66 6f 72 20 74 72 79 6f 70 74 20 69 6e 20 24 74  for tryopt in $t
0960: 72 79 6f 70 74 73 20 5f 5f 66 61 69 6c 5f 5f 3b  ryopts __fail__;
0970: 20 64 6f 0a 09 09 43 46 4c 41 47 53 3d 22 24 7b   do...CFLAGS="${
0980: 53 41 56 45 5f 43 46 4c 41 47 53 7d 22 0a 09 09  SAVE_CFLAGS}"...
0990: 4c 49 42 53 3d 22 24 7b 53 41 56 45 5f 4c 49 42  LIBS="${SAVE_LIB
09a0: 53 7d 22 0a 09 09 65 78 70 6f 72 74 20 43 46 4c  S}"...export CFL
09b0: 41 47 53 20 4c 49 42 53 0a 0a 09 09 23 20 43 6c  AGS LIBS....# Cl
09c0: 65 61 6e 20 75 70 2c 20 69 66 20 6e 65 65 64 65  ean up, if neede
09d0: 64 0a 09 09 6d 61 6b 65 20 64 69 73 74 63 6c 65  d...make distcle
09e0: 61 6e 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e  an >/dev/null 2>
09f0: 2f 64 65 76 2f 6e 75 6c 6c 0a 09 09 72 6d 20 2d  /dev/null...rm -
0a00: 72 66 20 22 24 7b 49 4e 53 54 44 49 52 7d 22 0a  rf "${INSTDIR}".
0a10: 09 09 6d 6b 64 69 72 20 22 24 7b 49 4e 53 54 44  ..mkdir "${INSTD
0a20: 49 52 7d 22 0a 0a 09 09 69 66 20 5b 20 22 24 7b  IR}"....if [ "${
0a30: 74 72 79 6f 70 74 7d 22 20 3d 20 22 5f 5f 66 61  tryopt}" = "__fa
0a40: 69 6c 5f 5f 22 20 5d 3b 20 74 68 65 6e 0a 09 09  il__" ]; then...
0a50: 09 65 78 69 74 20 31 0a 09 09 66 69 0a 0a 09 09  .exit 1...fi....
0a60: 69 66 20 5b 20 22 24 7b 74 72 79 6f 70 74 7d 22  if [ "${tryopt}"
0a70: 20 3d 3d 20 22 2d 2d 65 6e 61 62 6c 65 2d 73 68   == "--enable-sh
0a80: 61 72 65 64 22 20 5d 3b 20 74 68 65 6e 0a 09 09  ared" ]; then...
0a90: 09 69 73 73 68 61 72 65 64 3d 22 31 22 0a 09 09  .isshared="1"...
0aa0: 65 6c 73 65 0a 09 09 09 69 73 73 68 61 72 65 64  else....isshared
0ab0: 3d 22 30 22 0a 09 09 66 69 0a 0a 09 09 23 20 49  ="0"...fi....# I
0ac0: 66 20 62 75 69 6c 64 69 6e 67 20 61 20 73 68 61  f building a sha
0ad0: 72 65 64 20 54 4c 53 2c 20 61 64 64 20 74 68 65  red TLS, add the
0ae0: 20 4c 49 4e 4b 41 44 44 20 6c 69 62 72 61 72 69   LINKADD librari
0af0: 65 73 20 68 65 72 65 0a 09 09 69 66 20 5b 20 22  es here...if [ "
0b00: 24 7b 69 73 73 68 61 72 65 64 7d 22 20 3d 20 27  ${isshared}" = '
0b10: 31 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09 4c 49  1' ]; then....LI
0b20: 42 53 3d 22 24 7b 4c 49 42 53 7d 20 24 7b 4b 43  BS="${LIBS} ${KC
0b30: 5f 54 4c 53 5f 4c 49 4e 4b 41 44 44 7d 22 0a 09  _TLS_LINKADD}"..
0b40: 09 66 69 0a 0a 09 09 23 20 49 66 20 62 75 69 6c  .fi....# If buil
0b50: 64 20 61 20 73 74 61 74 69 63 20 54 4c 53 20 66  d a static TLS f
0b60: 6f 72 20 4b 69 74 44 4c 4c 2c 20 65 6e 73 75 72  or KitDLL, ensur
0b70: 65 20 74 68 61 74 20 77 65 20 75 73 65 20 50 49  e that we use PI
0b80: 43 0a 09 09 23 20 73 6f 20 74 68 61 74 20 69 74  C...# so that it
0b90: 20 63 61 6e 20 62 65 20 6c 69 6e 6b 65 64 20 69   can be linked i
0ba0: 6e 74 6f 20 74 68 65 20 73 68 61 72 65 64 20 6f  nto the shared o
0bb0: 62 6a 65 63 74 0a 09 09 69 66 20 5b 20 22 24 7b  bject...if [ "${
0bc0: 69 73 73 68 61 72 65 64 7d 22 20 3d 20 22 30 22  isshared}" = "0"
0bd0: 20 2d 61 20 22 24 7b 4b 49 54 54 41 52 47 45 54   -a "${KITTARGET
0be0: 7d 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b  }" = "kitdll" ];
0bf0: 20 74 68 65 6e 0a 09 09 09 43 46 4c 41 47 53 3d   then....CFLAGS=
0c00: 22 24 7b 43 46 4c 41 47 53 7d 20 2d 66 50 49 43  "${CFLAGS} -fPIC
0c10: 22 0a 09 09 66 69 0a 0a 09 09 69 66 20 5b 20 22  "...fi....if [ "
0c20: 24 7b 69 73 73 68 61 72 65 64 7d 22 20 3d 20 27  ${isshared}" = '
0c30: 30 27 20 5d 3b 20 74 68 65 6e 0a 09 09 09 73 65  0' ]; then....se
0c40: 64 20 27 73 40 55 53 45 5f 54 43 4c 5f 53 54 55  d 's@USE_TCL_STU
0c50: 42 53 40 58 58 58 5f 54 43 4c 5f 53 54 55 42 53  BS@XXX_TCL_STUBS
0c60: 40 67 27 20 63 6f 6e 66 69 67 75 72 65 20 3e 20  @g' configure > 
0c70: 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77 0a 09 09  configure.new...
0c80: 65 6c 73 65 0a 09 09 09 73 65 64 20 27 73 40 58  else....sed 's@X
0c90: 58 58 5f 54 43 4c 5f 53 54 55 42 53 40 55 53 45  XX_TCL_STUBS@USE
0ca0: 5f 54 43 4c 5f 53 54 55 42 53 40 67 27 20 63 6f  _TCL_STUBS@g' co
0cb0: 6e 66 69 67 75 72 65 20 3e 20 63 6f 6e 66 69 67  nfigure > config
0cc0: 75 72 65 2e 6e 65 77 0a 09 09 66 69 0a 09 09 63  ure.new...fi...c
0cd0: 61 74 20 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77  at configure.new
0ce0: 20 3e 20 63 6f 6e 66 69 67 75 72 65 0a 09 09 72   > configure...r
0cf0: 6d 20 2d 66 20 63 6f 6e 66 69 67 75 72 65 2e 6e  m -f configure.n
0d00: 65 77 0a 0a 09 09 28 0a 09 09 09 65 63 68 6f 20  ew....(....echo 
0d10: 22 52 75 6e 6e 69 6e 67 3a 20 2e 2f 63 6f 6e 66  "Running: ./conf
0d20: 69 67 75 72 65 20 24 74 72 79 6f 70 74 20 2d 2d  igure $tryopt --
0d30: 70 72 65 66 69 78 3d 5c 22 24 7b 49 4e 53 54 44  prefix=\"${INSTD
0d40: 49 52 7d 5c 22 20 2d 2d 65 78 65 63 2d 70 72 65  IR}\" --exec-pre
0d50: 66 69 78 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d  fix=\"${INSTDIR}
0d60: 5c 22 20 2d 2d 6c 69 62 64 69 72 3d 5c 22 24 7b  \" --libdir=\"${
0d70: 49 4e 53 54 44 49 52 7d 2f 6c 69 62 5c 22 20 2d  INSTDIR}/lib\" -
0d80: 2d 77 69 74 68 2d 74 63 6c 3d 5c 22 24 7b 54 43  -with-tcl=\"${TC
0d90: 4c 43 4f 4e 46 49 47 44 49 52 7d 5c 22 20 2d 2d  LCONFIGDIR}\" --
0da0: 77 69 74 68 2d 73 73 6c 2d 64 69 72 3d 5c 22 24  with-ssl-dir=\"$
0db0: 7b 53 53 4c 44 49 52 7d 5c 22 20 24 7b 43 4f 4e  {SSLDIR}\" ${CON
0dc0: 46 49 47 55 52 45 45 58 54 52 41 7d 22 0a 09 09  FIGUREEXTRA}"...
0dd0: 09 2e 2f 63 6f 6e 66 69 67 75 72 65 20 24 74 72  ../configure $tr
0de0: 79 6f 70 74 20 2d 2d 70 72 65 66 69 78 3d 22 24  yopt --prefix="$
0df0: 7b 49 4e 53 54 44 49 52 7d 22 20 2d 2d 65 78 65  {INSTDIR}" --exe
0e00: 63 2d 70 72 65 66 69 78 3d 22 24 7b 49 4e 53 54  c-prefix="${INST
0e10: 44 49 52 7d 22 20 2d 2d 6c 69 62 64 69 72 3d 22  DIR}" --libdir="
0e20: 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 22 20  ${INSTDIR}/lib" 
0e30: 2d 2d 77 69 74 68 2d 74 63 6c 3d 22 24 7b 54 43  --with-tcl="${TC
0e40: 4c 43 4f 4e 46 49 47 44 49 52 7d 22 20 2d 2d 77  LCONFIGDIR}" --w
0e50: 69 74 68 2d 73 73 6c 2d 64 69 72 3d 22 24 7b 53  ith-ssl-dir="${S
0e60: 53 4c 44 49 52 7d 22 20 24 7b 43 4f 4e 46 49 47  SLDIR}" ${CONFIG
0e70: 55 52 45 45 58 54 52 41 7d 0a 0a 09 09 09 65 63  UREEXTRA}.....ec
0e80: 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d  ho "Running: ${M
0e90: 41 4b 45 3a 2d 6d 61 6b 65 7d 20 74 63 6c 6c 69  AKE:-make} tclli
0ea0: 62 64 69 72 3d 5c 22 24 7b 49 4e 53 54 44 49 52  bdir=\"${INSTDIR
0eb0: 7d 2f 6c 69 62 5c 22 20 41 52 3d 5c 22 24 7b 41  }/lib\" AR=\"${A
0ec0: 52 3a 2d 61 72 7d 5c 22 20 52 41 4e 4c 49 42 3d  R:-ar}\" RANLIB=
0ed0: 5c 22 24 7b 52 41 4e 4c 49 42 3a 2d 72 61 6e 6c  \"${RANLIB:-ranl
0ee0: 69 62 7d 5c 22 22 0a 09 09 09 24 7b 4d 41 4b 45  ib}\""....${MAKE
0ef0: 3a 2d 6d 61 6b 65 7d 20 74 63 6c 6c 69 62 64 69  :-make} tcllibdi
0f00: 72 3d 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69  r="${INSTDIR}/li
0f10: 62 22 20 41 52 3d 22 24 7b 41 52 3a 2d 61 72 7d  b" AR="${AR:-ar}
0f20: 22 20 52 41 4e 4c 49 42 3d 22 24 7b 52 41 4e 4c  " RANLIB="${RANL
0f30: 49 42 3a 2d 72 61 6e 6c 69 62 7d 22 20 7c 7c 20  IB:-ranlib}" || 
0f40: 65 78 69 74 20 31 0a 0a 09 09 09 65 63 68 6f 20  exit 1.....echo 
0f50: 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45  "Running: ${MAKE
0f60: 3a 2d 6d 61 6b 65 7d 20 74 63 6c 6c 69 62 64 69  :-make} tcllibdi
0f70: 72 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c  r=\"${INSTDIR}/l
0f80: 69 62 5c 22 20 41 52 3d 5c 22 24 7b 41 52 3a 2d  ib\" AR=\"${AR:-
0f90: 61 72 7d 5c 22 20 52 41 4e 4c 49 42 3d 5c 22 24  ar}\" RANLIB=\"$
0fa0: 7b 52 41 4e 4c 49 42 3a 2d 72 61 6e 6c 69 62 7d  {RANLIB:-ranlib}
0fb0: 5c 22 20 69 6e 73 74 61 6c 6c 22 0a 09 09 09 24  \" install"....$
0fc0: 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 74 63 6c  {MAKE:-make} tcl
0fd0: 6c 69 62 64 69 72 3d 22 24 7b 49 4e 53 54 44 49  libdir="${INSTDI
0fe0: 52 7d 2f 6c 69 62 22 20 41 52 3d 22 24 7b 41 52  R}/lib" AR="${AR
0ff0: 3a 2d 61 72 7d 22 20 52 41 4e 4c 49 42 3d 22 24  :-ar}" RANLIB="$
1000: 7b 52 41 4e 4c 49 42 3a 2d 72 61 6e 6c 69 62 7d  {RANLIB:-ranlib}
1010: 22 20 69 6e 73 74 61 6c 6c 20 7c 7c 20 65 78 69  " install || exi
1020: 74 20 31 0a 09 09 29 20 7c 7c 20 63 6f 6e 74 69  t 1...) || conti
1030: 6e 75 65 0a 0a 09 09 23 20 44 65 74 65 72 6d 69  nue....# Determi
1040: 6e 65 20 53 53 4c 20 6c 69 62 72 61 72 79 20 64  ne SSL library d
1050: 69 72 65 63 74 6f 72 79 0a 09 09 53 53 4c 5f 4c  irectory...SSL_L
1060: 49 42 5f 44 49 52 3d 22 24 28 24 7b 4d 41 4b 45  IB_DIR="$(${MAKE
1070: 3a 2d 6d 61 6b 65 7d 20 2d 2d 70 72 69 6e 74 2d  :-make} --print-
1080: 64 61 74 61 2d 62 61 73 65 20 7c 20 61 77 6b 20  data-base | awk 
1090: 27 2f 5e 53 53 4c 5f 4c 49 42 5f 44 49 52 20 3d  '/^SSL_LIB_DIR =
10a0: 20 2f 7b 20 70 72 69 6e 74 20 7d 27 20 7c 20 73   /{ print }' | s
10b0: 65 64 20 27 73 40 5e 53 53 4c 5f 4c 49 42 5f 44  ed 's@^SSL_LIB_D
10c0: 49 52 20 3d 20 2a 40 40 27 29 22 0a 0a 09 09 65  IR = *@@')"....e
10d0: 63 68 6f 20 22 53 53 4c 5f 4c 49 42 5f 44 49 52  cho "SSL_LIB_DIR
10e0: 20 3d 20 24 7b 53 53 4c 5f 4c 49 42 5f 44 49 52   = ${SSL_LIB_DIR
10f0: 7d 22 0a 0a 09 09 62 72 65 61 6b 0a 09 64 6f 6e  }"....break..don
1100: 65 0a 0a 09 23 20 43 72 65 61 74 65 20 70 6b 67  e...# Create pkg
1110: 49 6e 64 65 78 20 69 66 20 6e 65 65 64 65 64 0a  Index if needed.
1120: 09 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 49 4e  .if [ ! -e "${IN
1130: 53 54 44 49 52 7d 2f 6c 69 62 2f 74 6c 73 24 7b  STDIR}/lib/tls${
1140: 54 4c 53 56 45 52 53 7d 2f 70 6b 67 49 6e 64 65  TLSVERS}/pkgInde
1150: 78 2e 74 63 6c 22 20 5d 3b 20 74 68 65 6e 0a 09  x.tcl" ]; then..
1160: 09 63 61 74 20 3c 3c 20 5f 45 4f 46 5f 20 3e 20  .cat << _EOF_ > 
1170: 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 2f  "${INSTDIR}/lib/
1180: 74 6c 73 24 7b 54 4c 53 56 45 52 53 7d 2f 70 6b  tls${TLSVERS}/pk
1190: 67 49 6e 64 65 78 2e 74 63 6c 22 0a 70 61 63 6b  gIndex.tcl".pack
11a0: 61 67 65 20 69 66 6e 65 65 64 65 64 20 74 6c 73  age ifneeded tls
11b0: 20 24 7b 54 4c 53 56 45 52 53 7d 20 5c 0a 20 20   ${TLSVERS} \.  
11c0: 20 20 22 5b 6c 69 73 74 20 73 6f 75 72 63 65 20    "[list source 
11d0: 5b 66 69 6c 65 20 6a 6f 69 6e 20 5c 24 64 69 72  [file join \$dir
11e0: 20 74 6c 73 2e 74 63 6c 5d 5d 20 3b 20 5c 0a 20   tls.tcl]] ; \. 
11f0: 20 20 20 20 5b 6c 69 73 74 20 6c 6f 61 64 20 7b      [list load {
1200: 7d 20 74 6c 73 5d 22 0a 5f 45 4f 46 5f 0a 09 66  } tls]"._EOF_..f
1210: 69 0a 0a 09 23 20 44 65 74 65 72 6d 69 6e 65 20  i...# Determine 
1220: 6e 61 6d 65 20 6f 66 20 73 74 61 74 69 63 20 6f  name of static o
1230: 62 6a 65 63 74 0a 09 4c 49 4e 4b 41 44 44 46 49  bject..LINKADDFI
1240: 4c 45 3d 22 24 28 66 69 6e 64 20 22 24 7b 49 4e  LE="$(find "${IN
1250: 53 54 44 49 52 7d 22 20 2d 6e 61 6d 65 20 27 2a  STDIR}" -name '*
1260: 2e 61 27 20 7c 20 68 65 61 64 20 2d 6e 20 31 29  .a' | head -n 1)
1270: 22 0a 09 69 66 20 5b 20 2d 6e 20 22 24 7b 4c 49  "..if [ -n "${LI
1280: 4e 4b 41 44 44 46 49 4c 45 7d 22 20 5d 3b 20 74  NKADDFILE}" ]; t
1290: 68 65 6e 0a 09 09 4c 49 4e 4b 41 44 44 46 49 4c  hen...LINKADDFIL
12a0: 45 3d 22 24 7b 4c 49 4e 4b 41 44 44 46 49 4c 45  E="${LINKADDFILE
12b0: 7d 2e 6c 69 6e 6b 61 64 64 22 0a 0a 09 09 23 23  }.linkadd"....##
12c0: 20 58 58 58 3a 20 54 4f 44 4f 3a 20 44 65 74 65   XXX: TODO: Dete
12d0: 72 6d 69 6e 65 20 77 68 61 74 20 77 65 20 61 63  rmine what we ac
12e0: 74 75 61 6c 6c 79 20 6e 65 65 64 20 74 6f 20 6c  tually need to l
12f0: 69 6e 6b 20 61 67 61 69 6e 73 74 0a 09 09 61 64  ink against...ad
1300: 64 6c 69 62 73 3d 22 2d 4c 24 7b 53 53 4c 5f 4c  dlibs="-L${SSL_L
1310: 49 42 5f 44 49 52 3a 2d 2f 6c 69 62 7d 20 2d 6c  IB_DIR:-/lib} -l
1320: 73 73 6c 20 2d 6c 63 72 79 70 74 6f 20 24 7b 4b  ssl -lcrypto ${K
1330: 43 5f 54 4c 53 5f 4c 49 4e 4b 41 44 44 7d 22 0a  C_TLS_LINKADD}".
1340: 09 09 61 64 64 6c 69 62 73 5f 73 74 61 74 69 63  ..addlibs_static
1350: 4f 6e 6c 79 3d 22 22 0a 09 09 69 66 20 5b 20 22  Only=""...if [ "
1360: 24 7b 4b 43 5f 54 4c 53 5f 4c 49 4e 4b 53 53 4c  ${KC_TLS_LINKSSL
1370: 53 54 41 54 49 43 7d 22 20 3d 20 27 31 27 20 5d  STATIC}" = '1' ]
1380: 3b 20 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 22  ; then....echo "
1390: 2d 57 6c 2c 2d 42 73 74 61 74 69 63 20 24 7b 61  -Wl,-Bstatic ${a
13a0: 64 64 6c 69 62 73 7d 20 24 7b 61 64 64 6c 69 62  ddlibs} ${addlib
13b0: 73 5f 73 74 61 74 69 63 4f 6e 6c 79 7d 20 2d 57  s_staticOnly} -W
13c0: 6c 2c 2d 42 64 79 6e 61 6d 69 63 22 0a 09 09 65  l,-Bdynamic"...e
13d0: 6c 73 65 0a 09 09 09 65 63 68 6f 20 22 24 7b 61  lse....echo "${a
13e0: 64 64 6c 69 62 73 7d 22 0a 09 09 66 69 20 3e 20  ddlibs}"...fi > 
13f0: 22 24 7b 4c 49 4e 4b 41 44 44 46 49 4c 45 7d 22  "${LINKADDFILE}"
1400: 0a 09 66 69 0a 0a 09 23 20 49 6e 73 74 61 6c 6c  ..fi...# Install
1410: 20 66 69 6c 65 73 20 6e 65 65 64 65 64 20 62 79   files needed by
1420: 20 69 6e 73 74 61 6c 6c 61 74 69 6f 6e 0a 09 63   installation..c
1430: 70 20 2d 72 20 22 24 7b 49 4e 53 54 44 49 52 7d  p -r "${INSTDIR}
1440: 2f 6c 69 62 22 20 22 24 7b 4f 55 54 44 49 52 7d  /lib" "${OUTDIR}
1450: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 66 69 6e  " || exit 1..fin
1460: 64 20 22 24 7b 4f 55 54 44 49 52 7d 22 20 2d 6e  d "${OUTDIR}" -n
1470: 61 6d 65 20 27 2a 2e 61 27 20 2d 74 79 70 65 20  ame '*.a' -type 
1480: 66 20 7c 20 78 61 72 67 73 20 2d 6e 20 31 20 72  f | xargs -n 1 r
1490: 6d 20 2d 66 20 2d 2d 0a 0a 09 65 78 69 74 20 30  m -f --...exit 0
14a0: 0a 29 20 7c 7c 20 65 78 69 74 20 31 0a 0a 65 78  .) || exit 1..ex
14b0: 69 74 20 30 0a                                   it 0.